# 1 "/home/kernel/COD/linux/arch/x86/kernel/macros.S"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "/home/kernel/COD/linux/include/linux/kconfig.h" 1




# 1 "./include/generated/autoconf.h" 1
# 6 "/home/kernel/COD/linux/include/linux/kconfig.h" 2
# 1 "<command-line>" 2
# 1 "/home/kernel/COD/linux/arch/x86/kernel/macros.S"
# 9 "/home/kernel/COD/linux/arch/x86/kernel/macros.S"
# 1 "/home/kernel/COD/linux/include/linux/compiler.h" 1




# 1 "/home/kernel/COD/linux/include/linux/compiler_types.h" 1
# 6 "/home/kernel/COD/linux/include/linux/compiler.h" 2
# 302 "/home/kernel/COD/linux/include/linux/compiler.h"
.macro ANNOTATE_UNREACHABLE counter:req
\counter:
 .pushsection .discard.unreachable
 .long \counter\()b -.
 .popsection
.endm

.macro ANNOTATE_REACHABLE counter:req
\counter:
 .pushsection .discard.reachable
 .long \counter\()b -.
 .popsection
.endm

.macro ASM_UNREACHABLE
999:
 .pushsection .discard.unreachable
 .long 999b - .
 .popsection
.endm
# 10 "/home/kernel/COD/linux/arch/x86/kernel/macros.S" 2
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/refcount.h" 1
# 10 "/home/kernel/COD/linux/arch/x86/include/asm/refcount.h"
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/asm.h" 1
# 125 "/home/kernel/COD/linux/arch/x86/include/asm/asm.h"
.macro ASM_EXTABLE_HANDLE from:req to:req handler:req
 .pushsection "__ex_table","a"
 .balign 4
 .long (\from) - .
 .long (\to) - .
 .long (\handler) - .
 .popsection
.endm
# 165 "/home/kernel/COD/linux/arch/x86/include/asm/asm.h"
.macro ALIGN_DESTINATION

 movl %edi,%ecx
 andl $7,%ecx
 jz 102f
 subl $8,%ecx
 negl %ecx
 subl %ecx,%edx
100: movb (%rsi),%al
101: movb %al,(%rdi)
 incq %rsi
 incq %rdi
 decl %ecx
 jnz 100b
102:
 .section .fixup,"ax"
103: addl %ecx,%edx
 jmp copy_user_handle_tail
 .previous

 ASM_EXTABLE_HANDLE 100b 103b ex_handler_uaccess
 ASM_EXTABLE_HANDLE 101b 103b ex_handler_uaccess
 .endm
# 11 "/home/kernel/COD/linux/arch/x86/include/asm/refcount.h" 2
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/bug.h" 1




# 1 "/home/kernel/COD/linux/include/linux/stringify.h" 1
# 6 "/home/kernel/COD/linux/arch/x86/include/asm/bug.h" 2
# 58 "/home/kernel/COD/linux/arch/x86/include/asm/bug.h"
.macro __BUG_REL val:req
 .long \val - 2b
.endm




.macro ASM_BUG ins:req file:req line:req flags:req size:req
1: \ins
 .pushsection __bug_table,"aw"
2: __BUG_REL val=1b # bug_entry::bug_addr
 __BUG_REL val=\file # bug_entry::file
 .word \line # bug_entry::line
 .word \flags # bug_entry::flags
 .org 2b+\size
 .popsection
.endm
# 12 "/home/kernel/COD/linux/arch/x86/include/asm/refcount.h" 2

.macro REFCOUNT_EXCEPTION counter:req
 .pushsection .text..refcount
111: lea \counter, %rcx
112: ud2
 ASM_UNREACHABLE
 .popsection
113: ASM_EXTABLE_HANDLE 112b 113b ex_handler_refcount
.endm


.macro REFCOUNT_CHECK_LT_ZERO counter:req
 js 111f
 REFCOUNT_EXCEPTION counter="\counter"
.endm


.macro REFCOUNT_CHECK_LE_ZERO counter:req
 jz 111f
 REFCOUNT_CHECK_LT_ZERO counter="\counter"
.endm


.macro REFCOUNT_ERROR counter:req
 jmp 111f
 REFCOUNT_EXCEPTION counter="\counter"
.endm
# 11 "/home/kernel/COD/linux/arch/x86/kernel/macros.S" 2
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/alternative-asm.h" 1
# 10 "/home/kernel/COD/linux/arch/x86/include/asm/alternative-asm.h"
.macro LOCK_PREFIX_HERE
 .pushsection .smp_locks,"a"
 .balign 4
 .long 671f - . # offset
 .popsection
671:
.endm

.macro LOCK_PREFIX insn:vararg
 LOCK_PREFIX_HERE
 lock \insn
.endm
# 36 "/home/kernel/COD/linux/arch/x86/include/asm/alternative-asm.h"
.macro altinstruction_entry orig alt feature orig_len alt_len pad_len
 .long \orig - .
 .long \alt - .
 .word \feature
 .byte \orig_len
 .byte \alt_len
 .byte \pad_len
.endm







.macro ALTERNATIVE oldinstr, newinstr, feature
140:
 \oldinstr
141:
 .skip -(((144f-143f)-(141b-140b)) > 0) * ((144f-143f)-(141b-140b)),0x90
142:

 .pushsection .altinstructions,"a"
 altinstruction_entry 140b,143f,\feature,142b-140b,144f-143f,142b-141b
 .popsection

 .pushsection .altinstr_replacement,"ax"
143:
 \newinstr
144:
 .popsection
.endm
# 87 "/home/kernel/COD/linux/arch/x86/include/asm/alternative-asm.h"
.macro ALTERNATIVE_2 oldinstr, newinstr1, feature1, newinstr2, feature2
140:
 \oldinstr
141:
 .skip -((((144f-143f) ^ (((144f-143f) ^ (145f-144f)) & -(-((144f-143f) < (145f-144f))))) - (141b-140b)) > 0) * (((144f-143f) ^ (((144f-143f) ^ (145f-144f)) & -(-((144f-143f) < (145f-144f))))) - (141b-140b)),0x90

142:

 .pushsection .altinstructions,"a"
 altinstruction_entry 140b,143f,\feature1,142b-140b,144f-143f,142b-141b
 altinstruction_entry 140b,144f,\feature2,142b-140b,145f-144f,142b-141b
 .popsection

 .pushsection .altinstr_replacement,"ax"
143:
 \newinstr1
144:
 \newinstr2
145:
 .popsection
.endm
# 12 "/home/kernel/COD/linux/arch/x86/kernel/macros.S" 2

# 1 "/home/kernel/COD/linux/arch/x86/include/asm/paravirt.h" 1







# 1 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_types.h" 1




# 1 "/home/kernel/COD/linux/include/linux/const.h" 1



# 1 "/home/kernel/COD/linux/include/uapi/linux/const.h" 1
# 5 "/home/kernel/COD/linux/include/linux/const.h" 2
# 6 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_types.h" 2
# 1 "/home/kernel/COD/linux/include/linux/mem_encrypt.h" 1
# 7 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_types.h" 2

# 1 "/home/kernel/COD/linux/arch/x86/include/asm/page_types.h" 1





# 1 "/home/kernel/COD/linux/include/linux/types.h" 1





# 1 "/home/kernel/COD/linux/include/uapi/linux/types.h" 1




# 1 "/home/kernel/COD/linux/arch/x86/include/uapi/asm/types.h" 1




# 1 "/home/kernel/COD/linux/include/uapi/asm-generic/types.h" 1






# 1 "/home/kernel/COD/linux/include/asm-generic/int-ll64.h" 1
# 11 "/home/kernel/COD/linux/include/asm-generic/int-ll64.h"
# 1 "/home/kernel/COD/linux/include/uapi/asm-generic/int-ll64.h" 1
# 12 "/home/kernel/COD/linux/include/uapi/asm-generic/int-ll64.h"
# 1 "/home/kernel/COD/linux/arch/x86/include/uapi/asm/bitsperlong.h" 1
# 11 "/home/kernel/COD/linux/arch/x86/include/uapi/asm/bitsperlong.h"
# 1 "/home/kernel/COD/linux/include/asm-generic/bitsperlong.h" 1




# 1 "/home/kernel/COD/linux/include/uapi/asm-generic/bitsperlong.h" 1
# 6 "/home/kernel/COD/linux/include/asm-generic/bitsperlong.h" 2
# 12 "/home/kernel/COD/linux/arch/x86/include/uapi/asm/bitsperlong.h" 2
# 13 "/home/kernel/COD/linux/include/uapi/asm-generic/int-ll64.h" 2
# 12 "/home/kernel/COD/linux/include/asm-generic/int-ll64.h" 2
# 8 "/home/kernel/COD/linux/include/uapi/asm-generic/types.h" 2
# 6 "/home/kernel/COD/linux/arch/x86/include/uapi/asm/types.h" 2
# 6 "/home/kernel/COD/linux/include/uapi/linux/types.h" 2
# 7 "/home/kernel/COD/linux/include/linux/types.h" 2
# 7 "/home/kernel/COD/linux/arch/x86/include/asm/page_types.h" 2
# 48 "/home/kernel/COD/linux/arch/x86/include/asm/page_types.h"
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/page_64_types.h" 1
# 49 "/home/kernel/COD/linux/arch/x86/include/asm/page_types.h" 2
# 9 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_types.h" 2
# 250 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_types.h"
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_64_types.h" 1




# 1 "/home/kernel/COD/linux/arch/x86/include/asm/sparsemem.h" 1
# 6 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_64_types.h" 2
# 251 "/home/kernel/COD/linux/arch/x86/include/asm/pgtable_types.h" 2
# 9 "/home/kernel/COD/linux/arch/x86/include/asm/paravirt.h" 2

# 1 "/home/kernel/COD/linux/arch/x86/include/asm/nospec-branch.h" 1





# 1 "/home/kernel/COD/linux/arch/x86/include/asm/alternative.h" 1
# 7 "/home/kernel/COD/linux/arch/x86/include/asm/nospec-branch.h" 2

# 1 "/home/kernel/COD/linux/arch/x86/include/asm/cpufeatures.h" 1





# 1 "/home/kernel/COD/linux/arch/x86/include/asm/required-features.h" 1
# 7 "/home/kernel/COD/linux/arch/x86/include/asm/cpufeatures.h" 2



# 1 "/home/kernel/COD/linux/arch/x86/include/asm/disabled-features.h" 1
# 11 "/home/kernel/COD/linux/arch/x86/include/asm/cpufeatures.h" 2
# 9 "/home/kernel/COD/linux/arch/x86/include/asm/nospec-branch.h" 2
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/msr-index.h" 1
# 10 "/home/kernel/COD/linux/arch/x86/include/asm/nospec-branch.h" 2
# 63 "/home/kernel/COD/linux/arch/x86/include/asm/nospec-branch.h"
.macro ANNOTATE_NOSPEC_ALTERNATIVE
 .Lannotate_\@:
 .pushsection .discard.nospec
 .long .Lannotate_\@ - .
 .popsection
.endm






.macro ANNOTATE_RETPOLINE_SAFE
 .Lannotate_\@:
 .pushsection .discard.retpoline_safe
 .quad .Lannotate_\@
 .popsection
.endm






.macro RETPOLINE_JMP reg:req
 call .Ldo_rop_\@
.Lspec_trap_\@:
 pause
 lfence
 jmp .Lspec_trap_\@
.Ldo_rop_\@:
 mov \reg, (%rsp)
 ret
.endm





.macro RETPOLINE_CALL reg:req
 jmp .Ldo_call_\@
.Ldo_retpoline_jmp_\@:
 RETPOLINE_JMP \reg
.Ldo_call_\@:
 call .Ldo_retpoline_jmp_\@
.endm






.macro JMP_NOSPEC reg:req

 ANNOTATE_NOSPEC_ALTERNATIVE
 ALTERNATIVE_2 "ANNOTATE_RETPOLINE_SAFE; jmp *\reg", "RETPOLINE_JMP \reg", ( 7*32+12), "lfence; ANNOTATE_RETPOLINE_SAFE; jmp *\reg", ( 7*32+13)





.endm

.macro CALL_NOSPEC reg:req

 ANNOTATE_NOSPEC_ALTERNATIVE
 ALTERNATIVE_2 "ANNOTATE_RETPOLINE_SAFE; call *\reg", "RETPOLINE_CALL \reg", ( 7*32+12), "lfence; ANNOTATE_RETPOLINE_SAFE; call *\reg", ( 7*32+13)





.endm





.macro FILL_RETURN_BUFFER reg:req nr:req ftr:req

 ANNOTATE_NOSPEC_ALTERNATIVE
 ALTERNATIVE "jmp .Lskip_rsb_\@", "mov $(\nr/2), \reg; 771: call 772f; 773: pause; lfence; jmp 773b; 772: call 774f; 775: pause; lfence; jmp 775b; 774: dec \reg; jnz 771b; add $(64/8) * \nr, %rsp;" \ftr


.Lskip_rsb_\@:

.endm
# 11 "/home/kernel/COD/linux/arch/x86/include/asm/paravirt.h" 2

# 1 "/home/kernel/COD/linux/arch/x86/include/asm/paravirt_types.h" 1
# 675 "/home/kernel/COD/linux/arch/x86/include/asm/paravirt_types.h"
.macro PARAVIRT_CALL type:req clobber:req pv_opptr:req
771: ANNOTATE_RETPOLINE_SAFE
 call *\pv_opptr
772: .pushsection .parainstructions,"a"
 .balign 8
 .quad 771b
 .byte \type
 .byte 772b-771b
 .short \clobber
 .popsection
.endm
# 13 "/home/kernel/COD/linux/arch/x86/include/asm/paravirt.h" 2
# 14 "/home/kernel/COD/linux/arch/x86/kernel/macros.S" 2

# 1 "/home/kernel/COD/linux/arch/x86/include/asm/cpufeature.h" 1
# 204 "/home/kernel/COD/linux/arch/x86/include/asm/cpufeature.h"
.macro STATIC_CPU_HAS bitnum:req cap_byte:req feature:req t_yes:req t_no:req always:req
1:
 jmp 6f
2:
 .skip -(((5f-4f) - (2b-1b)) > 0) * ((5f-4f) - (2b-1b)),0x90
3:
 .section .altinstructions,"a"
 .long 1b - .
 .long 4f - .
 .word \always
 .byte 3b - 1b
 .byte 5f - 4f
 .byte 3b - 2b
 .previous
 .section .altinstr_replacement,"ax"
4:
 jmp \t_no
5:
 .previous
 .section .altinstructions,"a"
 .long 1b - .
 .long 0
 .word \feature
 .byte 3b - 1b
 .byte 0
 .byte 0
 .previous
 .section .altinstr_aux,"ax"
6:
 testb \bitnum,\cap_byte
 jnz \t_yes
 jmp \t_no
 .previous
.endm
# 16 "/home/kernel/COD/linux/arch/x86/kernel/macros.S" 2
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/jump_label.h" 1
# 14 "/home/kernel/COD/linux/arch/x86/include/asm/jump_label.h"
# 1 "/home/kernel/COD/linux/arch/x86/include/asm/nops.h" 1
# 15 "/home/kernel/COD/linux/arch/x86/include/asm/jump_label.h" 2
# 44 "/home/kernel/COD/linux/arch/x86/include/asm/jump_label.h"
.macro STATIC_BRANCH_NOP l_yes:req key:req branch:req
.Lstatic_branch_nop_\@:
 .byte 0x0f,0x1f,0x44,0x00,0
.Lstatic_branch_no_after_\@:
 .pushsection __jump_table, "aw"
 .balign 8
 .long .Lstatic_branch_nop_\@ - ., \l_yes - .
 .quad \key + \branch - .
 .popsection
.endm

.macro STATIC_BRANCH_JMP l_yes:req key:req branch:req
.Lstatic_branch_jmp_\@:
 .byte 0xe9
 .long \l_yes - .Lstatic_branch_jmp_after_\@
.Lstatic_branch_jmp_after_\@:
 .pushsection __jump_table, "aw"
 .balign 8
 .long .Lstatic_branch_jmp_\@ - ., \l_yes - .
 .quad \key + \branch - .
 .popsection
.endm
# 16 "/home/kernel/COD/linux/arch/x86/kernel/macros.S" 2
